# Copyright (C) 2022 - 2025 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
Granta.BomAnalyticsServices.V2

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: V1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class GetSustainabilityForBomRequest(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "bom_xml": "str",
        "config": "CommonRequestConfig",
        "database_key": "str",
        "preferred_units": "CommonPreferredUnits",
    }

    attribute_map: dict[str, str] = {
        "bom_xml": "BomXml",
        "config": "Config",
        "database_key": "DatabaseKey",
        "preferred_units": "PreferredUnits",
    }

    subtype_mapping: dict[str, str] = {
        "PreferredUnits": "CommonPreferredUnits",
        "Config": "CommonRequestConfig",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        bom_xml: "Union[str, Unset_Type]" = Unset,
        config: "Union[CommonRequestConfig, Unset_Type]" = Unset,
        database_key: "Union[str, Unset_Type]" = Unset,
        preferred_units: "Union[CommonPreferredUnits, Unset_Type]" = Unset,
    ) -> None:
        """GetSustainabilityForBomRequest - a model defined in Swagger

        Parameters
        ----------
        bom_xml: str, optional
        config: CommonRequestConfig, optional
        database_key: str, optional
        preferred_units: CommonPreferredUnits, optional
        """
        self._bom_xml: Union[str, Unset_Type] = Unset
        self._preferred_units: Union[CommonPreferredUnits, Unset_Type] = Unset
        self._database_key: Union[str, Unset_Type] = Unset
        self._config: Union[CommonRequestConfig, Unset_Type] = Unset

        if bom_xml is not Unset:
            self.bom_xml = bom_xml
        if preferred_units is not Unset:
            self.preferred_units = preferred_units
        if database_key is not Unset:
            self.database_key = database_key
        if config is not Unset:
            self.config = config

    @property
    def bom_xml(self) -> "Union[str, Unset_Type]":
        """Gets the bom_xml of this GetSustainabilityForBomRequest.

        Returns
        -------
        Union[str, Unset_Type]
            The bom_xml of this GetSustainabilityForBomRequest.
        """
        return self._bom_xml

    @bom_xml.setter
    def bom_xml(self, bom_xml: "Union[str, Unset_Type]") -> None:
        """Sets the bom_xml of this GetSustainabilityForBomRequest.

        Parameters
        ----------
        bom_xml: Union[str, Unset_Type]
            The bom_xml of this GetSustainabilityForBomRequest.
        """
        # Field is not nullable
        if bom_xml is None:
            raise ValueError("Invalid value for 'bom_xml', must not be 'None'")
        self._bom_xml = bom_xml

    @property
    def preferred_units(self) -> "Union[CommonPreferredUnits, Unset_Type]":
        """Gets the preferred_units of this GetSustainabilityForBomRequest.

        Returns
        -------
        Union[CommonPreferredUnits, Unset_Type]
            The preferred_units of this GetSustainabilityForBomRequest.
        """
        return self._preferred_units

    @preferred_units.setter
    def preferred_units(self, preferred_units: "Union[CommonPreferredUnits, Unset_Type]") -> None:
        """Sets the preferred_units of this GetSustainabilityForBomRequest.

        Parameters
        ----------
        preferred_units: Union[CommonPreferredUnits, Unset_Type]
            The preferred_units of this GetSustainabilityForBomRequest.
        """
        # Field is not nullable
        if preferred_units is None:
            raise ValueError("Invalid value for 'preferred_units', must not be 'None'")
        self._preferred_units = preferred_units

    @property
    def database_key(self) -> "Union[str, Unset_Type]":
        """Gets the database_key of this GetSustainabilityForBomRequest.

        Returns
        -------
        Union[str, Unset_Type]
            The database_key of this GetSustainabilityForBomRequest.
        """
        return self._database_key

    @database_key.setter
    def database_key(self, database_key: "Union[str, Unset_Type]") -> None:
        """Sets the database_key of this GetSustainabilityForBomRequest.

        Parameters
        ----------
        database_key: Union[str, Unset_Type]
            The database_key of this GetSustainabilityForBomRequest.
        """
        # Field is not nullable
        if database_key is None:
            raise ValueError("Invalid value for 'database_key', must not be 'None'")
        self._database_key = database_key

    @property
    def config(self) -> "Union[CommonRequestConfig, Unset_Type]":
        """Gets the config of this GetSustainabilityForBomRequest.

        Returns
        -------
        Union[CommonRequestConfig, Unset_Type]
            The config of this GetSustainabilityForBomRequest.
        """
        return self._config

    @config.setter
    def config(self, config: "Union[CommonRequestConfig, Unset_Type]") -> None:
        """Sets the config of this GetSustainabilityForBomRequest.

        Parameters
        ----------
        config: Union[CommonRequestConfig, Unset_Type]
            The config of this GetSustainabilityForBomRequest.
        """
        # Field is not nullable
        if config is None:
            raise ValueError("Invalid value for 'config', must not be 'None'")
        self._config = config

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, GetSustainabilityForBomRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
